/****************************************************************************
*
*  Avoid.c
*
*  AvoidEdge and AvoidTilt
*
****************************************************************************/

#pragma chip PIC16F877

// ---- Include Files -------------------------------------------------------

#include "Avoid.h"
#include "Debug.h"
#include "Delay.h"
#include "Motor.h"
#include "Sensor.h"
#include "Tilt.h"
#include "Puts.h"

// ---- Private Constants and Types -----------------------------------------
// ---- Private Variables ---------------------------------------------------
// ---- Private Function Prototypes -----------------------------------------
// ---- Functions -----------------------------------------------------------

/***************************************************************************/
/**
*  AvoidEdge
*
*  Backs away from the edge
*/

extern void AvoidEdge( uns8 lineSide )
{
   uns8  i;

   // Back up a bit

   DBG( puts( "Avoid Edge: Backing up C: " ); )
   DBG( putu16( gHuntCounter ); )
   DBG( puts( "\n" ); )

   gSpeedL = SPEED_BWD;
   gSpeedR = SPEED_BWD;

   for ( i = 0; i < 30; i++ ) 
   {
      PulseMotors();
      WaitForTimer0Rollover();
   }

#if 1

   // I removed the turning part, since it should automatically turn in hunt
   // mode, and here we weren't checking the eye sensors (Accck)

#else
   DBG( puts( "Avoid Edge: Turning\n" ); )
   
   // Turn away from the line

   if (( lineSide & LINE_DETECTED_LEFT ) != 0 )
   {
      gSpeedL = SPEED_FWD;
   }
   else
   {
      gSpeedR = SPEED_FWD;
   }

   for ( i = 0; i < 30; i++ ) 
   {
      PulseMotors();
      WaitForTimer0Rollover();
   }
#endif

} // AvoidEdge

